#include<fstream>
using namespace std;
int main()
{
	ifstream f1("MATRANVUONG.INP");
	long long n;
	f1>>n;
	long long z[n][n];
	long long i,j;
	for(i=0;i<n;i++)
	{
		for(j=0;j<n;j
		++)
		{
			f1>>z[i][j];
		}
	}
	long long a=0;
	long long b=0;
	long long c=0;
	long long d=0;
	long long e=0;
	long long g=0;
	for(i=0;i<n;i++)
	{
		a+=z[i][i];
		b+=z[i][n-1-i];
		if(i<n-1)
		{
			c+=z[i][i+1];
			c+=z[i+1][i];
			d+=z[i+1][n-i-1];
			d+=z[i][n-2-i];
		} 
	}
	for(i=0;i<n;i++)
	{
		for(j=0;j<n;j++)
		{
			if(j>i) e+=z[i][j];
			if(j>(n-1-i)) g+=z[i][j];
		}
	}
	f1.close();
	ofstream f2("MATRANVUONG.OUT");
	f2<<a<<endl<<b<<endl<<c<<endl<<d<<endl<<e<<endl<<g<<endl;
	f2.close();
	return 0;
}
